_G.BlockThatBot = _G.BlockThatBot or {}
BlockThatBot._path = ModPath
BlockThatBot._data_path = SavePath .. "blockthatbot_2_settings.txt" --don't overwrite the original mod's save data
BlockThatBot._data = {enabled = true,characters = {}}
-- Save settings, but remove the settings file if we have nothing to save in it

function BlockThatBot:VerifyCharacters()
	for _,character in pairs(tweak_data.criminals.characters) do
		self._data.characters[character.name] = false
		log("First time setup: set " .. character.name .. " to unblocked by default")
	end
end
function BlockThatBot:Save(init)
	if init then 
		self:VerifyCharacters()
	end
	if next(self._data) == nil then
		os.remove( self._data_path )
	else
		local file = io.open( self._data_path, "w+" )
		if file then
			file:write( json.encode( self._data ) )
			file:close()
		end
	end
end

-- Load function taken straight from the example code!
function BlockThatBot:Load()
	local file = io.open( self._data_path, "r" )
	if file then
		self._data = json.decode( file:read("*all") )
		file:close()
	else
		BlockThatBot:Save(true)
	end
end

-- Localisation loading
Hooks:Add("LocalizationManagerPostInit", "LocalizationManagerPostInit_BlockThatBot", function( loc )
	loc:load_localization_file( BlockThatBot._path .. "loc/en.txt")
end)

function BlockThatBot:CreateMenu()
	log("creating menu")
	local menu_title = managers.localization:text("BlockThatBot_menu_name")
	local menu_msg = managers.localization:text("BlockThatBot_menu_desc")
	local is_blocked
	local options = {}
		for num,character in pairs(tweak_data.criminals.characters) do
			is_blocked = BlockThatBot._data.characters[character.name] and ("##" .. managers.localization:text("BlockThatBot_block_complete") .. "## ") or ""
			options[#options+1] = { --i hate you table.insert
				text = is_blocked .. managers.localization:text("menu_" .. character.name),
				callback = callback(self,self,"BlockCharacter",character.name)
			}
		end
		options[#options+1] = {
			text = managers.localization:text("BlockThatBot_quit_prompt"),
			is_cancel_button = true
		}
	QuickMenu:new(menu_title,menu_msg,options):show()
end
	

function BlockThatBot:BlockCharacter(name)
	if not name then
		return-- was to prevent an earlier crash; should be fine now
	end
	BlockThatBot._data.characters[name] = BlockThatBot._data.characters[name] == false
	BlockThatBot:Save()
--[[	originally this was for confirm dialogue but i realised it's super annoying. you can uncomment this block if you want, and comment the existing QuickMenu function if you want to restore it

	local blocked = managers.localization:text(BlockThatBot._data.characters[name] and "BlockThatBot_block_complete" or "BlockThatBot_unblock_complete")
		
	local menu_title = managers.localization:text("BlockThatBot_menu_name")
	local menu_msg = blocked .. " " .. managers.localization:text("menu_" .. name)
	local options = {
		{
			text = managers.localization:text("BlockThatBot_continue_prompt"),
			callback = callback(self,self,"CreateMenu")
		},
		{
			text = managers.localization:text("BlockThatBot_quit_prompt"),
			is_cancel_button = true
		}
	}
	QuickMenu:new(menu_title,menu_msg,options):show()
	--]]
	
	BlockThatBot:CreateMenu()
	
end

Hooks:Add( "MenuManagerInitialize", "MenuManagerInitialize_BlockThatBot", function(menu_manager)
	MenuCallbackHandler.callback_BlockThatBot_enable = function(self,item)
		local value = item:value() == 'on'
		BlockThatBot._data.enabled = value
		BlockThatBot:Save()
	end
	MenuCallbackHandler.callback_BlockThatBot_open_menu = function(self,item)
		BlockThatBot:CreateMenu()
	end
	MenuCallbackHandler.callback_BlockThatBot_close = function(this)
		BlockThatBot:Save()
	end
	BlockThatBot:Load()
	MenuHelper:LoadFromJsonFile(BlockThatBot._path .. "menu/options.txt", BlockThatBot, BlockThatBot._data)
end)

--[[
original mod menu setup; rip menuhelper 2k17

-- Menu setup
local menu_id = "BlockThatBot_menu"

-- Register our new menu
Hooks:Add("MenuManagerSetupCustomMenus", "MenuManagerSetupCustomMenus_BlockThatBot", function(menu_manager, nodes)
	MenuHelper:NewMenu( menu_id )
end)

-- Populate it with items and callbacks
Hooks:Add("MenuManagerPopulateCustomMenus", "MenuManagerPopulateCustomMenus_BlockThatBot", function(menu_manager, nodes)

	-- Create generic toggle handler that adds the bot's name to the data table if enabled, removes if disabled
	MenuCallbackHandler.BlockThatBot_toggle = function(self, item)
		
	
		BlockThatBot._data[item:name()] = (item:value() == "on") or nil
		BlockThatBot:Save()
	end

	-- Load settings
	BlockThatBot:Load()

	-- Add every available character to the menus using the game's own menu names
	for i = 1, CriminalsManager.get_num_characters() do
		local character = CriminalsManager.character_names()[i]

		MenuHelper:AddToggle({
			id = character,
			title = "menu_" .. character,
			desc = "BlockThatBot_toggle_desc",
			callback = "BlockThatBot_toggle",
			menu_id = menu_id,
			value = BlockThatBot._data[character] or false
		})
	end

end )

-- Build the menu and add it to the Mod Options menu
Hooks:Add("MenuManagerBuildCustomMenus", "MenuManagerBuildCustomMenus_BlockThatBot", function( menu_manager, nodes )
	nodes[menu_id] = MenuHelper:BuildMenu( menu_id )
	MenuHelper:AddMenuItem( MenuHelper:GetMenu("mods_options"), menu_id, "BlockThatBot_menu_name", "BlockThatBot_menu_desc" )
end)
--]]